package com.system_ken.bedsore;

import android.content.Context;
import android.content.SharedPreferences;
import android.content.pm.PackageManager;
import android.support.v4.app.FragmentTransaction;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.widget.EditText;
import android.widget.Spinner;
import android.widget.TextView;

public class MainActivity extends AppCompatActivity {
  MainFragment mainFragment;
  SettingFragment setting;

  FragmentTransaction transaction;

  EditText PatientID;
  TextView PatientName;
  TextView Gender;
  TextView BDay;

  public static String PackageName = "com.system_ken.bedsore";
  public static String prfName = "wrldPref";
  public static String Host_Name = "host_name";
  public static String Port_Number = "port_number";
  public static String Ward_Kubun = "ward_kubun";
  public static String BedSoreBunrui = "bunrui";
  public static String BedSoreKubun = "kubun";

  @Override
  protected void onCreate(Bundle savedInstanceState) {
    super.onCreate(savedInstanceState);
    setContentView(R.layout.activity_main);

    transaction = getSupportFragmentManager().beginTransaction();

    //シングルトンクラスの読込
    RecodDataRead();

    if ((RecordClass.HostName == null) || (RecordClass.PortNumber == null)) {
      if (setting == null) {
        setting = new SettingFragment();
        transaction.add(R.id.contents, setting);
      } else {
        transaction.replace(R.id.contents, setting);
      }
      transaction.commit();
    } else {
      if (mainFragment == null) {
        mainFragment = new MainFragment();
        transaction.add(R.id.contents, mainFragment);
      } else {
        transaction.replace(R.id.contents, mainFragment);
      }
      transaction.commit();
    }
  }

  //シングンルトンクラスの読込
  private void RecodDataRead() {
    try {
      Context other = createPackageContext(PackageName, Context.CONTEXT_IGNORE_SECURITY);
      SharedPreferences pref = getSharedPreferences(prfName, Context.MODE_PRIVATE);
      RecordClass.HostName = pref.getString(Host_Name, null);
      RecordClass.PortNumber = pref.getString(Port_Number, null);
      RecordClass.WardKubun = pref.getInt(Ward_Kubun, 0);
      RecordClass.Bunrui = pref.getInt(BedSoreBunrui, 0);
      RecordClass.Kubun = pref.getInt(BedSoreKubun, 0);
    } catch (PackageManager.NameNotFoundException e) {
      e.printStackTrace();
    }
  }

  @Override
  protected void onStart() {
    super.onStart();
  }
}
