package com.system_ken.bedsore;


import android.Manifest;
import android.content.ContentValues;
import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import android.content.pm.PackageManager;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.media.MediaScannerConnection;
import android.net.Uri;
import android.os.Bundle;
import android.provider.MediaStore;
import android.support.annotation.Nullable;
import android.support.v4.app.ActivityCompat;
import android.support.v4.app.Fragment;
import android.support.v4.app.FragmentTransaction;
import android.support.v4.content.ContextCompat;
import android.util.Base64;
import android.view.KeyEvent;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.view.inputmethod.InputMethodManager;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.Spinner;
import android.widget.TextView;
import android.widget.Toast;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.io.ByteArrayOutputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Formatter;

import okhttp3.Call;
import okhttp3.Callback;
import okhttp3.FormBody;
import okhttp3.MediaType;
import okhttp3.OkHttpClient;
import okhttp3.Request;
import okhttp3.RequestBody;
import okhttp3.Response;

import static com.system_ken.bedsore.MainActivity.BedSoreBunrui;
import static com.system_ken.bedsore.MainActivity.BedSoreKubun;
import static com.system_ken.bedsore.MainActivity.PackageName;
import static com.system_ken.bedsore.MainActivity.Ward_Kubun;
import static com.system_ken.bedsore.MainActivity.prfName;


/**
 * A simple {@link Fragment} subclass.
 */
public class MainFragment extends Fragment {
  SettingFragment setting;

  FragmentTransaction transaction;

  OkHttpClient okHttpClient = new OkHttpClient();
  public static final MediaType JSON = MediaType.parse("application/json; charset=utf-8");

  EditText patientID;
  TextView patientName;
  TextView gender;
  TextView bday;
  TextView msg;
  Button btn1;
  Button btn2;
  Button btn3;
  Spinner WardKubun;
  Spinner Bunrui;
  Spinner Kubun;
  ImageView imageView;

  //病棟区分
  ArrayList<String> list;
  ArrayAdapter<String> adapter;

  //褥瘡分類
  ArrayList<String> list2;
  ArrayAdapter<String> adapter2;

  //褥瘡区分
  ArrayList<String> list3;
  ArrayAdapter<String> adapter3;

  Boolean startFLG = true;
  String photoName;
  private Uri m_uri;
  private Uri resultUri;
  private static final int REQUEST_CHOOSER = 1000;
  public String str = null;

  public MainFragment() {
    // Required empty public constructor
  }

  @Override
  public void onCreate(@Nullable Bundle savedInstanceState) {
    super.onCreate(savedInstanceState);

    okHttpClient = new OkHttpClient();
    startFLG = false;
  }

  @Override
  public void onStart() {
    super.onStart();

    patientID = (EditText) getActivity().findViewById(R.id.editText);
    patientName = (TextView) getActivity().findViewById(R.id.textView2);
    gender = (TextView) getActivity().findViewById(R.id.textView4);
    bday = (TextView) getActivity().findViewById(R.id.textView5);
    msg = (TextView) getActivity().findViewById(R.id.textView12);
    btn1 = (Button) getActivity().findViewById(R.id.button);
    btn2 = (Button) getActivity().findViewById(R.id.button2);
    btn3 = (Button) getActivity().findViewById(R.id.button3);
    WardKubun = (Spinner) getActivity().findViewById(R.id.spinner);
    Bunrui = (Spinner) getActivity().findViewById(R.id.spinner2);
    Kubun = (Spinner) getActivity().findViewById(R.id.spinner3);
    imageView = (ImageView) getActivity().findViewById(R.id.imageView);

    //病棟区分の設定
    list = new ArrayList<String>();
    //Adapterの作成
    adapter = new ArrayAdapter<String>(getActivity(), R.layout.spiner_item, list);
    //dropdownのレイアウトを指定
    adapter.setDropDownViewResource(R.layout.spiner_dropdown_item);

    //褥瘡分類の設定
    list2 = new ArrayList<String>();
    adapter2 = new ArrayAdapter<String>(getActivity(), R.layout.spiner_item, list2);
    adapter2.setDropDownViewResource(R.layout.spiner_dropdown_item);

    //褥瘡分類の設定
    list3 = new ArrayList<String>();
    adapter3 = new ArrayAdapter<String>(getActivity(), R.layout.spiner_item, list3);
    adapter3.setDropDownViewResource(R.layout.spiner_dropdown_item);

    transaction = getActivity().getSupportFragmentManager().beginTransaction();

    if (RecordClass.Ward_Kubun == null) {
      WardKubunRead();
    }

    if (startFLG == true) {

    } else {
      MainFragmentCLS();
    }

    if (RecordClass.Ward_Kubun != null) {
      WardKubunSet();
      if (RecordClass.Bunrui != null) {
        BedSoreBuruiSet();
      }
    }


    //撮影
    btn1.setOnClickListener(new View.OnClickListener() {
      @Override
      public void onClick(View v) {
        Photographing();
      }
    });
    //CLS
    btn2.setOnClickListener(new View.OnClickListener() {
      @Override
      public void onClick(View v) {
        MainFragmentCLS();
        //ソフトウエアキーボードを表示する
        InputMethodManager imm = (InputMethodManager) getActivity().getSystemService(Context.INPUT_METHOD_SERVICE);
        imm.showSoftInput(patientID, 0);
      }
    });
    //設定
    btn3.setOnClickListener(new View.OnClickListener() {
      @Override
      public void onClick(View v) {
        if (setting == null) setting = new SettingFragment();
        transaction.replace(R.id.contents, setting);
        transaction.commit();
      }
    });

    //病棟区分選択
    WardKubun.setOnItemSelectedListener(new AdapterView.OnItemSelectedListener() {
      @Override
      public void onItemSelected(AdapterView<?> parent, View view, int position, long id) {
        Integer Kubun = WardKubun.getSelectedItemPosition();

        try {
          Context other = getActivity().createPackageContext(PackageName, Context.CONTEXT_IGNORE_SECURITY);
          SharedPreferences pref = getActivity().getSharedPreferences(prfName, Context.MODE_PRIVATE);
          SharedPreferences.Editor editor = pref.edit();
          editor.putInt(Ward_Kubun, Kubun);
          editor.commit();
        } catch (PackageManager.NameNotFoundException e) {
          e.printStackTrace();
        }
      }

      @Override
      public void onNothingSelected(AdapterView<?> parent) {
        Toast.makeText(getContext(), "病棟区分 Not Select", Toast.LENGTH_SHORT).show();
      }
    });
    //褥瘡分類選択
    Bunrui.setOnItemSelectedListener(new AdapterView.OnItemSelectedListener() {
      @Override
      public void onItemSelected(AdapterView<?> parent, View view, int position, long id) {
        Integer bunrui = Bunrui.getSelectedItemPosition();

        try {
          Context other = getActivity().createPackageContext(PackageName, Context.CONTEXT_IGNORE_SECURITY);
          SharedPreferences pref = getActivity().getSharedPreferences(prfName, Context.MODE_PRIVATE);
          SharedPreferences.Editor editor = pref.edit();
          editor.putInt(BedSoreBunrui, bunrui);
          RecordClass.Kubun = 0;
          editor.commit();
          KubunRead(bunrui);
        } catch (PackageManager.NameNotFoundException e) {
          e.printStackTrace();
        }
      }

      @Override
      public void onNothingSelected(AdapterView<?> parent) {
        Toast.makeText(getContext(), "分類 Not Select", Toast.LENGTH_SHORT).show();
      }
    });
    //褥瘡区分選択
    Kubun.setOnItemSelectedListener(new AdapterView.OnItemSelectedListener() {
      @Override
      public void onItemSelected(AdapterView<?> parent, View view, int position, long id) {
        Integer kubun = Kubun.getSelectedItemPosition();

        try {
          Context other = getActivity().createPackageContext(PackageName, Context.CONTEXT_IGNORE_SECURITY);
          SharedPreferences pref = getActivity().getSharedPreferences(prfName, Context.MODE_PRIVATE);
          SharedPreferences.Editor editor = pref.edit();
          editor.putInt(BedSoreKubun, kubun);
          editor.commit();
        } catch (PackageManager.NameNotFoundException e) {
          e.printStackTrace();
        }
      }

      @Override
      public void onNothingSelected(AdapterView<?> parent) {

      }
    });
    //患者検索
    patientID.setOnKeyListener(new View.OnKeyListener() {
      @Override
      public boolean onKey(View v, int keyCode, KeyEvent event) {
        if ((event.getAction() == KeyEvent.ACTION_DOWN) && (keyCode == KeyEvent.KEYCODE_ENTER)) {
          PatientInfo(patientID.getText().toString());
          btn1.setEnabled(true);
        }
        return false;
      }
    });
  }

  @Override
  public View onCreateView(LayoutInflater inflater, ViewGroup container,
                           Bundle savedInstanceState) {
    // Inflate the layout for this fragment
    return inflater.inflate(R.layout.fragment_main, container, false);
  }

  //褥瘡区分読込
  private void KubunRead(Integer bunrui) {
    String url = "http://" + RecordClass.HostName + ":" +
                             RecordClass.PortNumber +
                             "/BedSoreKubunList?Request=" + String.valueOf(bunrui + 1);

    //リクエストを作成
    Request request = new Request.Builder().url(url).build();
    Call call = okHttpClient.newCall(request);

    //リクエストを非同期実行
    call.enqueue(new Callback() {
      @Override
      public void onFailure(Call call, IOException e) {
        Toast.makeText(getContext(), "接続失敗", Toast.LENGTH_SHORT).show();
      }

      @Override
      public void onResponse(Call call, Response response) throws IOException {
        String body = response.body().string();
        JSONObject obj = null;
        try {
          obj = new JSONObject(body);
          final String JSON = obj.getString("Result");
          getActivity().runOnUiThread(new Runnable() {
            @Override
            public void run() {
              JSONArray Arry = null;
              list3.clear();
              try {
                Arry = new JSONArray(JSON);
                for (int lp = 0; lp < Arry.length(); lp++) {
                  JSONObject obj = Arry.getJSONObject(lp);
                  list3.add(obj.getString("Kubun"));
                }
                Kubun.setAdapter(adapter3);
                Kubun.setSelection(RecordClass.Kubun);
              } catch (JSONException e) {
                e.printStackTrace();
              }
            }
          });
        } catch (JSONException e) {
          e.printStackTrace();
        }
      }
    });
  }

  //褥瘡分類読込
  private void BunruiRead() {
    String url = "http://" + RecordClass.HostName + ":" + RecordClass.PortNumber + "/BedSoreBunruiList";

    //リクエストを作成
    Request request = new Request.Builder().url(url).build();
    Call call = okHttpClient.newCall(request);

    //リクエストを非同期実行
    call.enqueue(new Callback() {
      @Override
      public void onFailure(Call call, IOException e) {
        Toast.makeText(getContext(), e.toString(), Toast.LENGTH_SHORT).show();
      }

      @Override
      public void onResponse(Call call, Response response) throws IOException {
        String body = response.body().string();
        JSONObject obj = null;
        try {
          obj = new JSONObject(body);
          final String JSON = obj.getString("Result");
          getActivity().runOnUiThread(new Runnable() {
            @Override
            public void run() {
              RecordClass.Bedsore_Bunrui = null;
              try {
                RecordClass.Bedsore_Bunrui = new JSONArray(JSON);
                BedSoreBuruiSet();
              } catch (JSONException e) {
                e.printStackTrace();
              }
            }
          });
        } catch (JSONException e) {
          e.printStackTrace();
        }
      }
    });
  }

  //褥瘡分類セット
  private void BedSoreBuruiSet() {
    for (int lp = 0; lp < RecordClass.Bedsore_Bunrui.length(); lp++) {
      JSONObject obj = null;
      try {
        obj = RecordClass.Bedsore_Bunrui.getJSONObject(lp);
        list2.add(obj.getString("Bunrui"));
      } catch (JSONException e) {
        e.printStackTrace();
      }
    }
    Bunrui.setAdapter(adapter2);
    Bunrui.setSelection(RecordClass.Bunrui);
  }

  //病棟区分の読込
  private void WardKubunRead() {
    String url = "http://" + RecordClass.HostName + ":" + RecordClass.PortNumber + "/WardKubunList";

    //リクエストを作成
    Request request = new Request.Builder().url(url).build();
    Call call = okHttpClient.newCall(request);

    //リクエストを非同期実行
    call.enqueue(new Callback() {
      @Override
      public void onFailure(Call call, IOException e) {
        if (setting == null) { setting = new SettingFragment(); }
        transaction.replace(R.id.contents, setting);
        transaction.commit();
      }

      @Override
      public void onResponse(Call call, Response response) throws IOException {
        String body = response.body().string();
        JSONObject obj = null;
        try {
          obj = new JSONObject(body);
          final String JSON = obj.getString("Result");
          getActivity().runOnUiThread(new Runnable() {
            @Override
            public void run() {
              RecordClass.Ward_Kubun = null;
              try {
                RecordClass.Ward_Kubun = new JSONArray(JSON);
                WardKubunSet();
                BunruiRead();
              } catch (JSONException e) {
                e.printStackTrace();
              }
            }
          });
        } catch (JSONException e) {
          e.printStackTrace();
        }
      }
    });
  }

  private void Photographing() {
    if (ContextCompat.checkSelfPermission(getContext(), Manifest.permission.CAMERA) == PackageManager.PERMISSION_GRANTED) {
      //カメラへのアクセスを許可されている時の処理
      if (ContextCompat.checkSelfPermission(getContext(), Manifest.permission.WRITE_EXTERNAL_STORAGE) == PackageManager.PERMISSION_GRANTED) {
        //ストレージへのアクセスを許可されている時の処理
        CameraOpen();
      } else {
        //ストレージへのアクセスを許可されていない時の処理
        if (ActivityCompat.shouldShowRequestPermissionRationale(getActivity(), Manifest.permission.WRITE_EXTERNAL_STORAGE)) {
          //拒否された時 Permissionが必要な理由を表示して再度許可を求めたり、機能を無効にしたりします。
        } else {
          //まだ許可を求める前の時、許可を求めるダイアログを表示します。
          ActivityCompat.requestPermissions(getActivity(), new String[]{Manifest.permission.WRITE_EXTERNAL_STORAGE}, 0);
        }
      }
    } else {
      //カメラへのアクセスを許可されていない時の処理
      if (ActivityCompat.shouldShowRequestPermissionRationale(getActivity(), Manifest.permission.CAMERA)) {
        //拒否された時 Permissionが必要な理由を表示して再度許可を求めたり、機能を無効にしたりします。
      } else {
        //まだ許可を求める前の時、許可を求めるダイアログを表示します。
        ActivityCompat.requestPermissions(getActivity(), new String[]{Manifest.permission.CAMERA}, 0);
      }
    }
  }

  private void CameraOpen() {
    photoName = System.currentTimeMillis() + ".jpg";

    ContentValues contentValues = new ContentValues();

    contentValues.put(MediaStore.Images.Media.TITLE, photoName);
    contentValues.put(MediaStore.Images.Media.MIME_TYPE, "image/jpeg");

    m_uri = getActivity().getContentResolver().insert(MediaStore.Images.Media.EXTERNAL_CONTENT_URI, contentValues);

    Intent intentCamera = new Intent(MediaStore.ACTION_IMAGE_CAPTURE);
    intentCamera.putExtra(MediaStore.EXTRA_OUTPUT, m_uri);

    startActivityForResult(intentCamera, REQUEST_CHOOSER);
  }

  @Override
  public void onActivityResult(int requestCode, int resultCode, Intent data) {
    super.onActivityResult(requestCode, resultCode, data);

    startFLG = true;

    if (requestCode == REQUEST_CHOOSER) {
      if (resultCode != getActivity().RESULT_OK) {
        //キャンセル時
        Toast.makeText(getContext(), "キャンセル", Toast.LENGTH_SHORT).show();
        return;
      }
    }

    resultUri = (data != null ? data.getData() : m_uri);
    if (resultUri == null) {
      Toast.makeText(getContext(), "取得失敗", Toast.LENGTH_SHORT).show();
      return;
    }

    //ギャラリーへスキャンを促す
    MediaScannerConnection.scanFile(
        getContext(),
        new String[]{resultUri.getPath()},
        new String[]{"image/jpeg"},
        null);

    //画像を転送
    InputStream inputStream = null;
    ByteArrayOutputStream baos = new ByteArrayOutputStream();

    try {
      inputStream = getActivity().getContentResolver().openInputStream(resultUri);
    } catch (FileNotFoundException e) {
      e.printStackTrace();
    }

    Bitmap bmp = BitmapFactory.decodeStream(inputStream);
    bmp.compress(Bitmap.CompressFormat.JPEG, 100, baos);
    byte[] b = baos.toByteArray();
    String strBMP = Base64.encodeToString(b, Base64.DEFAULT);

    JSONObject obj = new JSONObject();
    //現在の日時を取得する
    Calendar calendar = Calendar.getInstance();
    //日付のフォーマットパターンを指定
    SimpleDateFormat sdf = new SimpleDateFormat("yyyy/MM/dd hh:mm:ss");
    SimpleDateFormat sdf2 = new SimpleDateFormat("yyyy_MM_dd_hh_mm_ss");
    //IDのフォーマットを指定
    Formatter fm = new Formatter();
    fm.format("%06d", Integer.parseInt(patientID.getText().toString()));

    String FileName = "ID"  + fm + "_" +
        Bunrui.getSelectedItem().toString() + "_"  +
        Kubun.getSelectedItem().toString() + "_"  +
        sdf2.format(calendar.getTime()) + ".jpg";

    try {
      obj.put("PATIENT_ID", Integer.parseInt(patientID.getText().toString()));
      obj.put("STUDY_DATE", sdf.format(calendar.getTime()));
      obj.put("BYOUTOU_NAME", WardKubun.getSelectedItem().toString());
      obj.put("DECUBITUS_BUNRUI", Bunrui.getSelectedItem().toString());
      obj.put("DECUBITUS_KUBUN", Kubun.getSelectedItem().toString());
      obj.put("FILE_NAME", FileName);
      obj.put("DECUBITUS_PICTURE", strBMP);
    } catch (JSONException e) {
      e.printStackTrace();
    }

    JSONObject obj2 = new JSONObject();
    try {
      obj2.put("Request", obj);
    } catch (JSONException e) {
      e.printStackTrace();
    }
    BedSoreTransfer(obj2);

    //画像を表示
    imageView.setImageURI(resultUri);
  }

  private void BedSoreTransfer(JSONObject obj) {
    String url = "http://" + RecordClass.HostName + ":" + RecordClass.PortNumber + "/PictureTransfer";

    MediaType MIMEType= MediaType.parse("application/json; charset=utf-8");

    //リクエストを作成
    RequestBody requestBody = RequestBody.create (MIMEType, obj.toString());

    Request request = new Request.Builder().url(url).post(requestBody).build();
    Call call = okHttpClient.newCall(request);
    call.enqueue(new Callback() {
      @Override
      public void onFailure(Call call, IOException e) {
        str = e.toString();
      }

      @Override
      public void onResponse(Call call, Response response) throws IOException {
        String body = response.body().string();
        if (body.equals("OK")) {
          str = "転送完了";
        } else {
          str = "転送失敗";
        }
        try {
          getActivity().getContentResolver().delete(resultUri, null, null);
        } catch (Exception e) {
          str = "写真の削除失敗";
        }
        getActivity().runOnUiThread(new Runnable() {
          @Override
          public void run() {
            msg.setText(str);
          }
        });
      }
    });
  }

  private void PatientInfo(String PatientID) {
    String Request = "/PatientInfo?Request=" + PatientID;
    String url = "http://" + RecordClass.HostName + ":" + RecordClass.PortNumber + Request;

    //リクエストを作成
    Request request = new Request.Builder().url(url).build();
    Call call = okHttpClient.newCall(request);
    call.enqueue(new Callback() {
      @Override
      public void onFailure(Call call, IOException e) {
        Toast.makeText(getContext(), e.toString(), Toast.LENGTH_SHORT).show();
      }

      @Override
      public void onResponse(Call call, Response response) throws IOException {
        String body = response.body().string();
        JSONObject obj = null;
        try {
          obj = new JSONObject(body);
          final String JSON = obj.getString("Result");
          getActivity().runOnUiThread(new Runnable() {
            @Override
            public void run() {
              try {
                JSONObject info = new JSONObject(JSON);
                patientName.setText(info.getString("Name"));
                gender.setText(info.getString("Gender"));
                bday.setText(info.getString("BDay"));
              } catch (JSONException e) {
                e.printStackTrace();
              }
            }
          });
        } catch (JSONException e) {
          e.printStackTrace();
        }
      }
    });
  }

  private void MainFragmentCLS() {
    patientID.setText("");
    patientName.setText("");
    gender.setText("");
    bday.setText("");
    msg.setText("");
    btn1.setEnabled(false);
    patientID.requestFocus();
  }

  //病棟区分セット
  private void WardKubunSet() {
    for (int lp = 0; lp < RecordClass.Ward_Kubun.length(); lp++) {
      JSONObject obj = null;
      try {
        obj = RecordClass.Ward_Kubun.getJSONObject(lp);
        list.add(obj.getString("WardKubun"));
      } catch (JSONException e) {
        e.printStackTrace();
      }
    }
    WardKubun.setAdapter(adapter);
    WardKubun.setSelection(RecordClass.WardKubun);
  }
}
