package com.system_ken.bedsore;


import android.content.Context;
import android.content.SharedPreferences;
import android.content.pm.PackageManager;
import android.os.Bundle;
import android.support.v4.app.Fragment;
import android.support.v4.app.FragmentTransaction;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.view.inputmethod.InputMethodManager;
import android.widget.Button;
import android.widget.EditText;
import android.widget.Toast;

import static com.system_ken.bedsore.MainActivity.PackageName;


/**
 * A simple {@link Fragment} subclass.
 */
public class SettingFragment extends Fragment {
  MainFragment main;

  FragmentTransaction transaction;

  EditText host1;
  EditText host2;
  EditText host3;
  EditText host4;
  EditText portNumber;
  Button btn1;
  Button btn2;
  Button btn3;

  public static String PackageName = "com.system_ken.bedsore";
  public static String prfName = "wrldPref";
  public static String Host_Name = "host_name";
  public static String Port_Number = "port_number";

  public SettingFragment() {
    // Required empty public constructor
  }


  @Override
  public View onCreateView(LayoutInflater inflater, ViewGroup container,
                           Bundle savedInstanceState) {
    // Inflate the layout for this fragment
    return inflater.inflate(R.layout.fragment_setting, container, false);
  }

  @Override
  public void onStart() {
    super.onStart();

    host1 = (EditText) getActivity().findViewById(R.id.editText2);
    host2 = (EditText) getActivity().findViewById(R.id.editText3);
    host3 = (EditText) getActivity().findViewById(R.id.editText4);
    host4 = (EditText) getActivity().findViewById(R.id.editText5);
    portNumber = (EditText) getActivity().findViewById(R.id.editText6);
    btn1 = (Button) getActivity().findViewById(R.id.button4);
    btn2 = (Button) getActivity().findViewById(R.id.button5);
    btn3 = (Button) getActivity().findViewById(R.id.button6);

    if (RecordClass.HostName == null) {
      host1.setText("192");
      host2.setText("168");
      host3.setText("0");
      host4.setText("0");
      portNumber.setText("8080");
    } else {
      String buf = RecordClass.HostName;
      host1.setText(buf.substring(0, buf.indexOf(".")));
      buf = buf.substring(buf.indexOf(".") + 1, buf.length());
      host2.setText(buf.substring(0, buf.indexOf(".")));
      buf = buf.substring(buf.indexOf(".") + 1, buf.length());
      host3.setText(buf.substring(0, buf.indexOf(".")));
      buf = buf.substring(buf.indexOf(".") + 1, buf.length());
      host4.setText(buf);
      portNumber.setText(RecordClass.PortNumber);
    }

    transaction = getActivity().getSupportFragmentManager().beginTransaction();

    host1.setNextFocusDownId(R.id.editText3);
    host1.setSelection(host1.length());

    host2.setNextFocusDownId(R.id.editText4);
    host2.setSelection(host2.length());

    host3.setNextFocusDownId(R.id.editText5);
    host3.setSelection(host3.length());

    host4.setNextFocusDownId(R.id.editText6);
    host4.setSelection(host4.length());

    portNumber.setSelection(portNumber.length());

    //設定
    btn1.setOnClickListener(new View.OnClickListener() {
      @Override
      public void onClick(View v) {
        SettingDataSave();
        ReturnToMain();
      }
    });
    //クリア
    btn2.setOnClickListener(new View.OnClickListener() {
      @Override
      public void onClick(View v) {
        ConnectSettingCLS();
      }
    });
    //キャンセル
    btn3.setOnClickListener(new View.OnClickListener() {
      @Override
      public void onClick(View v) {
        ReturnToMain();
      }
    });
  }

  @Override
  public void onResume() {
    super.onResume();

    //ソフトウエアキーボードを表示する
    InputMethodManager imm = (InputMethodManager) getActivity().getSystemService(Context.INPUT_METHOD_SERVICE);
    imm.showSoftInput(host1, 0);
    host1.requestFocus();
  }

  private void SettingDataSave() {
    String HostName = host1.getText().toString() + "." +
        host2.getText().toString() + "." +
        host3.getText().toString() + "." +
        host4.getText().toString();

    try {
      Context other = getActivity().createPackageContext(PackageName, Context.CONTEXT_IGNORE_SECURITY);
      SharedPreferences pref = getActivity().getSharedPreferences(prfName, Context.MODE_PRIVATE);
      SharedPreferences.Editor editor = pref.edit();
      editor.putString(Host_Name, HostName);
      editor.putString(Port_Number, portNumber.getText().toString());

      editor.commit();

      RecordClass.HostName = HostName;
    } catch (PackageManager.NameNotFoundException e) {
      e.printStackTrace();
      Toast.makeText(getActivity(), e.toString(), Toast.LENGTH_SHORT).show();
    }
  }

  private void ConnectSettingCLS() {
    host1.setText("");
    host2.setText("");
    host3.setText("");
    host4.setText("");
    portNumber.setText("");
    host1.requestFocus();
  }

  private void ReturnToMain() {
    if (main == null) main = new MainFragment();
    transaction.replace(R.id.contents, main);
    transaction.commit();
  }
}
